package backupmanager;

import java.io.File;
import java.io.FileInputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

public class Main {

	public static void main(String[] args) {
		// TODO Auto-generated method stub

		String cfgFileStr = (args[0] != null ? args[0] : BackupManagerConsts.BKMNGCONFFILE) ;
		String action = ((args[1] != null && BackupManagerConsts.ACTIONLIST.contains(args[1])) ? args[1] : BackupManagerConsts.BKMNGACTION_PRINTSYNCH);
		boolean forceUpdate = ((args[2] != null && Integer.parseInt(args[2]) == 1) ? true : false);
		boolean forceRemove = ((args[3] != null && Integer.parseInt(args[3]) == 1) ? true : false);

		File cfgFile = new File(cfgFileStr);

		if(cfgFile.exists() && !cfgFile.isDirectory()) {
			DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
			Date date = new Date();
			System.out.println("Starting BackupManager at " + dateFormat.format(date) + "...");

			BackupManager bkMng = null;

			try {
				Properties props = new Properties();
				props.load(new FileInputStream(cfgFile));

				// Default: NAS Windows
				bkMng = new BackupManagerNasWin(props);

				if(BackupManagerConsts.BKMNGACTION_SYNCHRONIZE.equals(action)) {
					bkMng.synchronize(forceUpdate, forceRemove);
					// bkMng.printSynch();
				} else {
					bkMng.printSynch();
				}

			} catch(Exception e) {
				System.err.println("ERROR: Unhandled Exception: " + e.getMessage());
				System.err.println("ERROR: View log for details.");
				System.out.println("ERROR: Unhandled Exception: " + e.getMessage());
				for(StackTraceElement ste : e.getStackTrace()) {
					System.out.println(ste.toString());
				}
			} finally {
				/*try {
					bkMng.shutDown();
				}
				catch(Exception e) {}*/
			}

			try {
				bkMng.shutDown();
			}
			catch(Exception e) {}

			date = new Date();
			System.out.println("BackupManager ended at " + dateFormat.format(date) + ".");

			System.exit(0);
		} else {
			System.out.println("ERROR: " + cfgFileStr + " is not a valid configuration file.");
			System.exit(1);
		}
	}

}
